require "defines"

local sqrt = math.sqrt
local ceil = math.ceil

local roadworks, floors, checkers

local roadtiles,roadtype={},{}

function init()

	checkers = {}
	for modname,callname in pairs(remote.interfaces) do
		if callname["BumperRoadCheck"] then
			table.insert(checkers,modname)
			--game.player.print("Detected mod "..modname)
		end
	end

	if not glob.steerdata then glob.steerdata = {x=0,y=0,o=0,ticks=10,last=0} end
	roadworks,floors=false,false
	for k,v in pairs(game.entityprototypes) do
		if v.type=="decorative" and v.name=="concrete-floor" then
			floors=true
			roadtype = {
			["concrete-floor"]=true,
			["stone-floor"]=true,
			["wood-floor"]=true,
			["wood-floor-2"]=true,
			["concrete-floor"]=true, 
			["concrete-floor-2"]=true, 
			["metal-floor"]=true, 
			["plastic-floor-red"]=true, 
			["plastic-floor-green"]=true, 
			["plastic-floor-blue"]=true, 
			["plastic-floor-yellow"]=true, 
			["plastic-floor-chess"]=true,
			}
			for k,_ in pairs(roadtype) do roadtype[k.."-connected"]=true end
		end
		if v.type=="simple-entity" and v.name=="RW-concretepavement" then
			roadworks=true
			roadtiles = {
				["RW-concretepavement"]=true,
				["RW-asphaltroad"]=true,
				["RW-cobblestonepath"]=true,
				}
		end
	end
end

game.onsave(function()
 glob.ticks=ticks
 glob.steerdata = steerdata
end)

game.onload(init)
game.oninit(function()
init()
--[[ testing is easier with free stuff
game.player.insert{name="concrete-floor",count=10000}
game.player.insert{name="floor-o-matic",count=1}
game.player.insert{name="floor-b-gone",count=1}
--]]
end)

local function RoadAt(x,y)

	for _,m in pairs(checkers) do
		if remote.call(m,"BumperRoadCheck",x,y) then return true end
	end

	if roadworks and roadtiles[game.gettile(x,y).name] then return true end
	
	if floors then
		x = ceil(x)-.4
		y = ceil(y)-.4
		local list=game.findentitiesfiltered{area={{x-1.1,y-1.1},{x+1.1,y+1.1}},type="resource"}
		for _,e in pairs(list) do if roadtype[e.name] then return true end end
		list=game.findentitiesfiltered{area={{x-1.1,y-1.1},{x+1.1,y+1.1}},type="decorative"}
		for _,e in pairs(list) do if roadtype[e.name] then return true end end
	end
	
	--add more mods?
	return false
end

local function GuideCar(vehicle,steerdata)
	if steerdata.o == vehicle.orientation then
		local dx, dy, scale, l,r, steps, breadth
		local posx,posy = vehicle.position.x,vehicle.position.y
		dx = posx - steerdata.x
		dy = posy - steerdata.y
		if dx==0 and dy==0 then return end
		scale = 1/sqrt(dx*dx+dy*dy)
		dx,dy=dx*scale,dy*scale
		--game.player.print(scale)
		steps=1
		while steps<5 and RoadAt(posx+dx*steps,posy+dy*steps) do
			steps = steps + 1
		end
		repeat
			l=RoadAt(posx+dx*steps+dy,posy+dy*steps-dx)
			r=RoadAt(posx+dx*steps-dy,posy+dy*steps+dx)
			if l==r then 
				l=RoadAt(posx+dx*steps+dy*2,posy+dy*steps-dx*2)
				r=RoadAt(posx+dx*steps-dy*2,posy+dy*steps+dx*2)
			end
			steps=steps-1
		until steps<1 or l~=r
		
		if r~=l then
			dx = ceil((18+steerdata.last)/scale/(steps+1))--72/4/scale /2
			if dx>4 then dx = 4 end
			--game.player.print(dx)
			--local old=vehicle.orientation
			if l then
				vehicle.orientation = (ceil(vehicle.orientation*200-.5)-dx)/200
			else
				vehicle.orientation = (ceil(vehicle.orientation*200-.5)+dx)/200
			end
			--game.player.print(tostring(dx)..": "..tostring(vehicle.orientation-old))
			steerdata.last=dx
		end
	end
	steerdata.o = vehicle.orientation
	steerdata.x = vehicle.position.x
	steerdata.y = vehicle.position.y
end

game.onevent(defines.events.ontick, function(event)
	local steer = glob.steerdata
	if steer.ticks > 0 then steer.ticks = steer.ticks - 1 return end
	local v = game.player.vehicle
	if not v then steer.ticks=20 return end
	if not v.orientation then return end
	if not RoadAt(v.position.x,v.position.y) then
		if steer.last<1 then steer.ticks = 2 return end
		steer.last=steer.last-1
	end
	
	return GuideCar(v,steer)
end)
